#include <bits/stdc++.h>
using namespace std;
#define ll long long
vector<pair<int, int> > s;
vector<int> m;
vector<int> tree;
vector<int> tree1;

void build1(int v, int l, int r) {
    if (l == r - 1) {
        tree1[v] = m[l];
        return;
    }
    int mid = (l + r) / 2;
    build1(v * 2, l, mid);
    build1(v * 2 + 1, mid, r);
}
int rmq(int v, int vl, int vr, int ql, int qr) {
    if (qr <= vl || vr <= ql) return -1;
    if (vl >= ql && vr <= qr) return tree1[v];
    int mid = (vl + vr) / 2;
    return max(rmq(v * 2, vl, mid, ql, qr), rmq(v * 2 + 1, mid, vr, ql, qr));
}
void update(int v, int vl, int vr, int i) {
    if (vl == i) {
        tree[v] = 1;
        return;
    }
    int mid = (vl + vr) / 2;
    if (mid > i) {
        update(2 * v, vr, mid, mid);
    } else {
        update(2 * v + 1, mid, vr, mid);
    }
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}
void build(int v, int l, int r) {
    if (r == l- 1) {
        tree[v] = 1;
        return;
    }
    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid, r);
}
int get(int v, int l, int r, int i) {
    if (l == r - 1) {
        return l;
    }
    int mid = (l + r) / 2;
    if (tree[2 * v] < i) {
        return get(2 * v + 1, mid, r, i);
    } else {
        i -= tree[2 * v];
        return get(2 * v, l, mid, i);
    }
}


signed main() {
    int n;
    cin >> n;
    vector<int> h(n);
    vector<int> pref(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        pref[i + 1] = pref[i] + h[i];
    }
    s.resize(n);
    m = h;
    tree.resize(4 * n);
    tree1.resize(4 * n);
    build(1, 0, n);
    build1(1, 0, n);
    for (int i = 0; i < n; i++) {
        s[i] = {i, i + 1};
    }
    for (int j = 0; j < n - 1; j++) {
        int k;
        cin >> k;
        k--;
        int i = get(1, 0, n, k);
        update(1, 0, n, i);
        s[i] = make_pair(s[i].first, s[i + 1].second);
        s[i + 1] = {-1, -1};
        cout << rmq(1, 0, n, s[i].first, s[i].second) * (s[i].second - s[i].first) - (pref[s[i].second] - pref[s[i].first]) <<endl;
    }
    return 0;
}
